<?php

/******************************************************/
/* Enhanced Downloads Module - V2.0                   */
/* ================================                   */
/*                                                    */
/* Released: September 8, 2003                        */
/* Copyright (c) 2002 by Shawn Archer                 */
/* shawn@nukestyles.com                               */
/* http://www.NukeStyles.com                          */
/*                                                    */
/******************************************************/
/*                                                    */
/* Copyright Notice:                                  */
/* =================                                  */
/*                                                    */
/* THIS MODULE IS NOT RELEASED UNDER THE GPL/GNU      */
/* LICENSE.                                           */
/*                                                    */
/* You can modifiy all files, EXCEPT the copyright    */
/* file, to your liking. But you CANNOT redistribute  */
/* this module for any purpose, without the EXPRESS   */
/* WRITTEN CONSENT from Shawn Archer.                 */
/*                                                    */
/* Also, Francisco Burzi & the Nuke credits MUST      */
/* also remain. Please be fair with everyone that     */
/* helps you with this great CMS System.              */
/*                                                    */
/******************************************************/


########################################################################
#  Nuke Styles Enhanced Downloads Settings - New Language Definitions  #
########################################################################



######  Deleted Definitions from 1.0 - 1.6   ######

// define("_NSDLSETTINGS","NukeStyles.com Extra Downloads Settings");
// define("_NSDLPAGE","Results Per Page Options");
// define("_NSDLFEATUREINFO","Featured Download Information");
// define("_NSDLFEATURE","Featured Link Box Settings");
// define("_NSDLADDDOWNLOAD2","Below, choose to Allow Users in...........");
// define("_NSDLVOTE2","The options below determine............");
// define("_NSDLVOTE","Vote & Rating Options");
// define("_NSDLNEWPERPAGE","You can set the number of ..........");



######    New Definitions from 1.0 - 1.6   ######

define("_NSDLAUTOADDDOWNLOAD","Automatically validate new submissions?");



######  Modified Definitions from 1.0 - 1.6  ######

define("_NSDLLINKIMAGE","Download Link Image");
define("_NSDLLINKIMAGEPOS","Download Link Position");
define("_NSDLFEATURE1NAME","Featured 1 Name");
define("_NSDLFEATURE1LINK","Featured 1 Link");
define("_NSDLFEATURE1INFO","Featured 1 Desc");
define("_NSDLFEATURE2NAME","Featured 2 Name");
define("_NSDLFEATURE2LINK","Featured 2 Link");
define("_NSDLFEATURE2INFO","Featured 2 Desc");
define("_NSDLFEATURE3NAME","Featured 3 Name");
define("_NSDLFEATURE3LINK","Featured 3 Link");
define("_NSDLFEATURE3INFO","Featured 3 Desc");
define("_NSDLFEATURE4NAME","Featured 4 Name");
define("_NSDLFEATURE4LINK","Featured 4 Link");
define("_NSDLFEATURE4INFO","Featured 4 Desc");



####################################################


define("_NSERRORNOCOMPAT","ERROR: You need to type in a Compatibility Value!");
define("_NSERRORNOFILE","ERROR: You need to type in a Filesize!");
define("_NSENTEREMAIL","ERROR: You need to type in a email!");
define("_NSEMAILNOVALID","ERROR: The email you entered");
define("_NSEMAILNOVALID2","is not valid!");
define("_NSDLALLOWHTML","Allow HTML Coding in Descriptions");
define("_NSDLAFFILIATELINKS","Allow Affiliate Links to be Submitted");
define("_NSDLSHOWNUMFULLDL","Show total number of Downloads in Index");
define("_NSDLSHOWSUBCATS","Show the Sub Categories under Main Categories");
define("_NSDLOUTVOTE","Allow webmasters to use outside rating forms");
define("_NSDLFOOTBUTTON","Show Buttons <b>instead</b> of Text Links in DownloadFooter");
define("_NSDLSHOWNUMDL","Show number of Downloads next to Category");
define("_NSDLLINKIMAGE2","Below are 2 settings to control your Download Title Image. You MUST put the image in each themes main image folder (themes/Your_Theme/images/image.gif). The Image Position setting, lets you move your image up & down, depending on it's size. Vertical-align only works on IE.");
define("_NSDLTITLEIMAGE","Title Link Image Settings");
define("_NSDLDESIMAGE1","Below are the settings that control your Description Image. Turn this feature on or off... and if on, then set the images position inside the description, and set the standard width & height of the image. Also, turn on or off the Pop Up window to display the full size of the image, and set the width & height of the pop up window.");
define("_NSDLDESIMAGE","Description Image Settings");
define("_NSDLDESIMAGE2","Turn the Description Images on or off");
define("_NSDLDESIMAGE3","If this setting is off, below settings do not apply.");
define("_NSDLDESIMGPOSITION","Image Position in Description");
define("_NSDLLEFT","Left Top");
define("_NDSLRIGHT","Right Top");
define("_NSDLDESIMAGEWID","Standard image width");
define("_NSDLDESIMAGEHEI","Standard image height");
define("_NSDLPOPWIN","Turn the Pop Up window on or off");
define("_NSDLPOPWINWID","Standard Pop Up window width");
define("_NSDLPOPWINHEI","Standard Pop Up window height");
define("_NSDLFEATURELINKS","Turn Featured Link Box on or off");
define("_NSDLMORESETTINGS","More Download Settings");
define("_NSDLPERPAGE","Number of Downloads Shown per page");
define("_NSDLSEARCHPERPAGE","Number of Search Results per page");
define("_NSDLNEWPERPAGE1","Set number for first period");
define("_NSDLNEWPERPAGE2","Set number for second period");
define("_NSDLNEWPERPAGE3","Set number for third period");
define("_NSDLNEWIMAGEON","Turn on or off the New Image");
define("_NSDLNEWIMAGE1","Number of days considered 'Brand New'");
define("_NSDLNEWIMAGE2","Number of days considered 'Relatively New'");
define("_NSDLNEWIMAGE3","Number of days considered 'Getting Old'");
define("_NSDLADD","Add & Modify Download Options");
define("_NSDLADDDOWNLOAD","Allow Users to Add Downloads");
define("_NSDLANONADDDOWNLOAD","Allow Anonymous User to Add Downloads");
define("_NSDLADDDOWNLOADEMAIL","New submissions <b>must</b> include email");
define("_NSDLADDDOWNLOADFILE","New submissions <b>must</b> include filesize");
define("_NSDLMODDOWNLOAD","Allow Registered Members to suggest Modifications");
define("_NSDLANONMODDOWNLOAD","Allow Anonymous Users to suggest Modifications");
define("_NSDLNEW","New Downloads Options");
define("_NSDLPOPPERPAGE","Popular Downloads Options");
define("_NSDLPOPPERPAGE1","Number of Hits to make Download Popular");
define("_NSDLPOPPERPAGE2","Number or Percentage to show");
define("_NSDLPOPPERPAGE3","Show Popular as a Percentage?");
define("_NSDLPOPIMAGEON","Turn on or off Popular Download Image");
define("_NSDLPOPIMAGE","Image for Popular Download");
define("_NSDLPOPIMAGE2","Must be in: html/modules/Downloads/images/ - folder");
define("_NSDLTOPPERPAGE","Top Rated Downloads Options");
define("_NSDLTOPPERPAGE1","Number of Votes to make Download Top Rated");
define("_NSDLTOPPERPAGE2","Number or Percentage to show");
define("_NSDLTOPPERPAGE3","Show Top Rated as a Percentage?");
define("_NSDLVOTEANWAIT","Number of days Anonymous voters have to wait");
define("_NSDLVOTEOUTWAIT","Number of days Outside voters have to wait");
define("_NSDLVOTEANWEIGHT","Number of Anonymous votes vs. 1 Registered vote");
define("_NSDLVOTEOUTWEIGHT","Number of Outside votes vs. 1 Registered vote");
define("_NSDLVOTEMAINDEC","Main Rating Decimal out to X places");
define("_NSDLVOTEADDDEC","Detailed Rating Decimal out to X places");
define("_NSDLVDAYS","Day");
define("_NSDLVDAYS1","Days");
define("_NSDLVDAYS4","Week");
define("_NSDLVDAYS5","Weeks");
define("_NSDLADDDOWNLOADCOMPAT","New submissions <b>must</b> include compatibility");
define("_NSON","On");
define("_NSOFF","Off");
define("_DEFAULTIS","Default Number is");
define("_NSCOMPAT","Compatibility");
define("_NSDESIMAGE","Description Image URL");
define("_NSYES","Yes");
define("_NSNO","No");
define("_NSTOP","Top of page");



#######################################################################




define("_NSDLEDLSETTINGS","NukeStyles EDL V2.0 Settings");
define("_NSDLDOWNLOADREPORTER","Reporter");
define("_NSDLDOWNLOADOWNER","Owner");
define("_NSDLDOWNLOADAUTHOR","Auther");
define("_NSDLSURECLEANVOTE","<font color=\"#CC0000\">Warning!</font><br><br>Are you sure you want to clean <b>all</b> Download Votes?");
define("_NSDLMUSTADDMAINCAT","You need to add a <a href=\"admin.php?op=downloads_add_cat#addcat\">Main Category</a> before adding a Sub-Category.");
define("_NSDLMUSTADDDL","You need to add a <a href=\"admin.php?op=downloads_add#adddl\">New Download</a> before Modifying one. =)");
define("_NSDLUNEEDTOADDCAT","You need to add another <a href=\"admin.php?op=downloads_add_cat#addcat\">Category</a> before you can Transfer.");
define("_NSDLUNEEDTOADDCAT2","You need to add a <a href=\"admin.php?op=downloads_add_cat#addcat\">Category</a> before Modifying one. =)");
define("_NSDLUNEEDTOADDCAT3","You need to add a <a href=\"admin.php?op=downloads_add#adddl\">Category</a> before Adding a Download.");
define("_NSDLUNDERMAIN","In Main Cateogry");
define("_NSDLBADDCAT","Add Category");
define("_NSDLBADDSUBCAT","Add Sub-Category");
define("_NSDLSUBMITTER","Submitter");
define("_NSCHECKALL","Check All");
define("_NSDLDOWNSTATUS","Status");
define("_NSDLENABLED","Enabled");
define("_NSDLDISABLED","Disabled");
define("_NSDLNOBACK","Go Back");
define("_NSDLCATADDED","New Category Added");
define("_NSDLSUBCATADDED","New Sub Category Added");
define("_NSDLUPLOAD","Upload");
define("_NSDLCATNOTE","Note: (Category Notes show only when viewing the Category)");


// New after first Beta release


define("_NSDLNODOWNLOADSADDED","No New Downloads added.");
define("_NSDLNOCATTITLE","You didn't type in a Category Title.");
define("_ERRORNOCATSELECTED","ERROR: You need to choose a Category.");



// New after second Beta release

define("_NSDLDISABLEDLIST","List of Disabled Downloads");
define("_NSDLNODISABLED","No Downloads are Disabled");

define("_NSDLBENABLE","Enable");



define("_NSDLBDEDIT"," Edit ");

define("_NSDLDISABLE","Disable");

define("_NSDLSUREDELETEDL","<font color=\"#CC0000\">Warning!</font><br><br>Are you sure you want to Delete this Download?");

define("_MODDOWNLOAD2","Modify Download by ID#");


################################
#                              #
#   Admin Block Definitions    #
#                              #
################################

define("_NSDLNUKEDOWN","Nuke Downloads");
define("_NSDLGENERALSET","General Settings");
define("_NSDLDESIGNTBS","Design Tables");
define("_NSDLUPLOADSET","Upload Settings");
define("_NSDLBATCHPROC","Batch Process");
define("_NSDLDESCRIPTIONIMGS","Description Images");
define("_NSDLADDMODSET","Add/Modify Settings");

define("_NSDLRATECONFIG","Ratings Config");
define("_NSDLNEWPOPSET","New-Pop-Top Config");
define("_NSDLOPTIMIZETBS","Optimize Tables");
define("_NSDLCLEAN","Clean All Votes");
define("_NSBROKENDLS","Broken Reports");
define("_NSDLMODREQUEST","Mod Requests");
define("_NSDLVALIDATEDB","Validate Database");
define("_NSDLNEWDLS","New Downloads");
define("_NSDLWAITINGDOWNL","Waiting DL");
define("_NSDLADDDOWNL","Add Download");
define("_NSDLADDCAT","Add Category");
define("_NSDLADDSUBCAT","Add Sub-Category");
define("_NSDLMODDOWNL","Modify Download");
define("_NSDLMODIFYCAT","Modify Category");
define("_NSDLTRANSFER","Transfer Downloads");
define("_NSDLDISABLEDDLS","Disabled Downloads");



// Modified after 2nd Beta Release

define("_NSDLFEATUREDLINKS","Featured Downloads");


// New after second beta release

define("_NSDLGROUPSETTINGS","Group Settings");
define("_NSDLFIELDSETTINGS","Field Settings");

define("_NSDLIMGFILEMANG","File/Image Manager");




################################
#                              #
#  General Config Definitions  #
#                              #
################################

define("_NSDLGENSETTINGS","NukeStyles EDL V2.0 General Settings");
define("_NSDLFORCEREG","Force registration to Download files");
define("_NSDLSHOWBLOCKS","Show right blocks for EDL Module");
define("_NSDLDEFAULTSORT","Default Sort Order List");
define("_NSDLDOWNBUTTON","Show 'Download Now!' Button");
define("_NSDLPOPULARITY1","Hits: Least-Most");
define("_NSDLPOPULARITY2","Hits: Most-Least");
define("_NSDLTITLEAZ","Title: A-Z");
define("_NSDLTITLEZA","Title: Z-A");
define("_NSDLRATING1","Rating: Low-High");
define("_NSDLRATING2","Rating: High-Low");
define("_NSDLDDATE1","Date: Old First");
define("_NSDLDDATE2","Date: New First");
define("_NSDLLINKBAR","Show the Link Bar at bottom (Extra Menu Links)");
define("_NSDLSHOWENGINES","Show 'other' Search Engines in the Search Function");
define("_NSDLCATIMAGE","Category Image");
define("_NSDLCATIMAGEPOS","Category Image Position");
define("_NSDLSUBCATIMAGE","Sub-Category Image");
define("_NSDLSUBCATIMAGEPOS","Sub-Category Image Position");
define("_NSDLFEATUREDIMAGE","Featured Download Image");
define("_NSDLFEATUREDIMAGEPOS","Featured Download Position");
define("_NSDLTITLELINKIMG","Featured, Categories, & Download Images");

define("_NSDLADDDETAILCOLOR","Additional Details & New Downloads: Table & Text Colors");
define("_NSDLADDDETTBTOP","Table Top Color");
define("_NSDLADDDETTBBOT","Table Body Color");
define("_NSDLADDDETTEXTTOP","Text Top Color");
define("_NSDLADDDETTEXTBOT","Text Body Color");
define("_NSMAINDLNOTE","Downloads Main Note, shown above Menu.<br>Good for Copyrights & General Notices in DL section");
define("_NSMAINDLNOTE2","Show the Main download Note on <b>all</b> pages in the module?");

define("_NSDLMNALL","All Pages");
define("_NSDLMNMAIN","DL Main Only");

define("_NSDLEXAMTEXTTBTOP","Example Table & Text Top Colors");
define("_NSDLEXAMTEXTTBBOT","Example Table & Text Bottom Colors");



###############################
#                             #
#  General Help Definitions   #
#                             #
###############################

// gn_img.php

define("_NSDLHLPGENIMAGES","General Settings - Image Help");
define("_NSDLHLPFEATIMG","Featured Download Image");
define("_NSDLHLPFEATIMG2","The Featured Download Image setting, applies to the Featured Download shown on the main downloads page. This image will show in front of the actual link. Make this one more noticable to drive attention to your Featured Downloads.");
define("_NSDLHLPCATIMG","Main Category Image");
define("_NSDLHLPCATIMG2","The Main Category Image is the image shown in front of all the Main Categories throughout the Module.");
define("_NSDLHLPSUBCATIMG","Sub-Category Image");
define("_NSDLHLPSUBCATIMG2","The Sub-Category Image is the image shown in front of all the Sub-Category throughout the Module. If you do not have the option on to show the Sub-Categories, then disregard this setting.");
define("_NSDLHLPLINKIMG","Download Link Image");
define("_NSDLHLPLINKIMG2","This image will be shown in front of all Download Links, like in previous versions of the EDL.");


// Modified AFTER 2nd Beta release

define("_NSDLHLPGENIMAGES2","<b>*Note:</b> Place <b>all</b> of the images for these functions, in your <b>html/modules/Downloads/images/</b> directory. If the script detects no images for any of the settings, then it will show nothing. To see examples of these images, just visit <a href=\"http://www.nukestyles.com/modules.php?name=Downloads\" target=\"_blank\">NukeStyles</a>, and view how ours is set up.");


// New AFTER 2nd Beta release

// ad_col.php

define("_NSDLHLPADDCOLOR","Additional Details & New DL Color Help");
define("_NSDLHLPADDCOLOR2","You have the option to change the colors of the Additional Details & New Downloads table colors. It's very simple... Open up the color picker, choose the colors you wish to use, click the 'Submit' button, and then the color will appear in the form. When you save your general settings, the new colors will be applied to the Additional Details rating display. This display shows all the user submitted ratings; Registered User's, Unregistered User's, and Outside User ratings. An example of the colors you choose, will display under the color fields. Do <b>not</b> put a <b>#</b> before the color code... the script will do that by default.<br><br>The colors will also be applied to the New Downloads listing. For an example, if you click the New Downloads link from the module's menu, it will take you the default list of new downloads, sorted by 'Date'. The new colors will applied to that table.<br><br>Play around with the colors a bit, to get a feel of the changes. This option is <b>not</b> required. If your site uses just one theme, then it would benefit it greatly. If you use more than one theme, then there are other options you can do to change all the colors. It's explained in our Installation guidelines on NukeStyles.com.");





##############################
#                            #
#  Table Config Definitions  #
#                            #
##############################

define("_NSDLTABLESETTINGS","NukeStyles EDL V2.0 Theme & Table Configurations");
define("_NSDLTHNOTE","Theme Configurations");
define("_NSINSTALLTHM","Install Themes");
define("_NSBINSTALL"," Install ");
define("_NSEDITTB","Edit Theme Tables");
define("_NSBEDIT"," Load ");
define("_NSDLCHTHM","Choose Theme");
define("_NSDLUNINSTTH","Remove Theme");
define("_NSDLBUNINSTTH"," Remove ");
define("_NSDLSUREREMTH","<font color=\"#CC0000\">Warning!</font><br><br>Are you sure you want to Remove theme:");
define("_NSDLSUREREMTH2","This will delete all table configurations you have set for this theme.");
define("_NSDLSUREREMTB","<font color=\"#CC0000\">Warning!</font><br><br>Are you sure you want to delete this Table?");
define("_NSBYES"," Yes ");
define("_NSBNO","  No  ");
define("_NSDLBSAVE"," Save ");
define("_NSDLBSET"," Set Mode ");
define("_NSDLBSETUPDATE"," Update Mode ");
define("_NSDLBADDTB"," Add Table ");
define("_NSDLBADD","  Add  ");
define("_NSDLTEDIT","Edit");
define("_NSDLTDELETE","Delete");
define("_NSDLTVIEW","View");
define("_NSDLTBEDIT"," Edit Table ");
define("_NSDLTBDELETE"," Delete Table ");
define("_NSDLCLOSEHELP","Close Help");
define("_NSDLCLOSEVIEW","Close Window");
define("_NSDLCHNGMODE","Change Mode");
define("_NSDLBGO","  Go  ");
define("_NSDLPREVTB","Preview Table");
define("_NSDLBEDIT"," Edit Table ");
define("_NSDLBDELETE"," Delete Table ");
define("_NSDLCANCEL","Cancel");
define("_NSDLTABLETITLE","NukeStyles EDL Table Test");
define("_NSUSE","Use");
define("_NSDLHELP","Help");
define("_NSDLUSETBCF","Normal Open2 & Close2 tables");
define("_NSDLUSEDESIGN","Design Form tables");
define("_NSDLUSEHTML","Cut & Paste HTML tables");
define("_NSDLTBCUSTHTML","Cut & Paste HTML Table");
define("_NSDLTBNAME","Table");
define("_NSDLTBMODE","Table Mode");
define("_NSDLTBFUNC","Functions");
define("_NSDLOPPREVTB","Preview");
define("_NSDLOPADDTB","  Add  ");
define("_NSDLOPCANCEL"," Cancel ");
define("_NSDLTBPREVIEWTABLE","Preview of Custom Table");
define("_NSDLTBPREVIEWTABLE2","Preview Table");
define("_NSDLTBMNAME2","Design Form");
define("_NSDLTBMNAME3","Cut & Paste HTML");
define("_NSDLTBCUSTHTMLOPEN","OpenTable");
define("_NSDLTBCUSTHTMLCLOSE","CloseTable");
define("_NSDLTBBEDIT"," Edit ");
define("_NSDLTBDELETE","Delete");
define("_NSDLTBNOACTIVE","No active tables detected!");
define("_NSDLTBACTIVE","Status");
define("_NSDLACTTABLE","Activate Table?");
define("_NSDLTBACTIVATE","Activate");
define("_NSDLTBDEACTIVATE","Deactivate");
define("_NSDLTBSETFOR","Table Mode settings for theme:");
define("_NSDLTBCURRENT","Current Tables for theme:");
define("_NSDLTBCUSTOM","Structure Settings");
define("_NSDLTBWIDTH","Table Width");
define("_NSDLTBCELLPADD","Cell Padding");
define("_NSDLTBCELLSPACE","Cell Spacing");
define("_NSDLTBALIGN","Alignment");
define("_NSDLTBALIGNL","Left");
define("_NSDLTBALIGNC","Center");
define("_NSDLTBALIGNR","Right");
define("_NSDLTBBORDER","Border Size");
define("_NSDLTBCOLORSET","Color Settings");
define("_NSDLTBBORDERCLR","Border Color");
define("_NSDLTBTRCLR","&lt;TR&gt; Color");
define("_NSDLTBTDCLR","&lt;TD&gt; Color");
define("_NSDLTBBGCLR","Bg Color");
define("_NSDLTBBGIMG","Bg Image");
define("_NSDLTBBLANK","If none, leave blank");
define("_NSDLLB1","Go Back");
define("_NSDLLB2","Load Theme");
define("_NSDLLB3","Change Mode");
define("_NSDLLB4","Add Table");
define("_NSDLADDTBTHEME","Add Table for theme");



###############################
#                             #
#    Table Help Definitions   #
#                             #
###############################

// Window Title

define("_NSDLHLPTITLE","NukeStyles EDL V2.0 Admin Help");

// th_main.php

define("_NSDLHLPTHMAIN","Main Theme Configurations");
define("_NSDLHLPTHMAINNOTE","<b>Note:</b> Installing, Loading, or Uninstalling of themes for the Enhanced Downloads Module in no way effect any themes for the rest of your Website. The creating of tables are for the EDL V2.0 module <b>only</b>. So if you install or uninstall a particular theme, the regular themes for your site remain the same, and no changes are made to any loaded theme.");
define("_NSDLHLPTHINSTALL","Installing Themes");
define("_NSDLHLPTHINSTALL2","You must install each theme you wish to use for the module. Highlight the theme you wish to install, then click the 'Install' button below. The page will refresh, and you can either install more themes, or go onto the next step of Loading and working with that particular theme. The themes that are installed will no longer show up in the 'Install Themes' dropdown menu.");
define("_NSDLHLPTHLOAD","Loading Themes");
define("_NSDLHLPTHLOAD2","To work with a particular theme, you must first install the theme. After installing the theme, the theme will now appear in the 'Load Theme' dropdown menu. Highlight the theme you wish to work with, and then click the 'Load Theme' button. You will then be taken to the configurations for that theme to begin setting modes and creating tables.");
define("_NSDLHLPTHUNINSTALL","Uninstalling Themes");
define("_NSDLHLPTHUNINSTALL2","To uninstall a particular theme, highlight the theme you wish to remove, then click the 'Remove' button. This will delete the particular theme from the EDL Module, and also delete all tables, colors, and configurations you have set for that theme. Becareful not to remove a theme you are working with.");

// th_mode.php

define("_NSDLHLPTHMODE","Theme Mode Setting");
define("_NSDLHLPTHMODE2","Setting Modes");
define("_NSDLHLPTHMODESET","The mode setting determines which type of table will be used for the particular theme that you have loaded. There are 3 different types of table modes:");
define("_NSDLHLPTHMODESET1","Regular Open2 & Close2 Tables");
define("_NSDLHLPTHMODESET2","Design Form Tables");
define("_NSDLHLPTHMODESET3","Copy & Paste HTML Tables");
define("_NSDLHLPTHMODESET4","The first mode, 'Regular Open2 & Close2 tables', will make default the regular OpenTable2 & CloseTable2 tables defined in your theme's main configurations. With this mode, you will not need to create or configure any tables. The table configurations will be pulled from your normal theme.php file.<br><br>The 'Design Form' mode, will allow you to create generic tables, with various settings, from a pre-designed form. You can set width, alignment, padding, spacing, colors, and background images for any table. The tables will then bypass the regular theme's Open2 & Close2 tables, and use the ones you configured.<br><br>The last mode, 'Copy & Paste HTML', allows you to create tables in an editor, and copy and paste the codes right into the form. You can create the 'Open' & 'Close' part of the tables, just like you would configure in your normal theme. This gives you the option to create any table design you choose.<br><br>With the 'Design Form' and 'Copy & Paste' modes, you can create any number of tables, which you can activate, deactivate, edit, modify, or any number of different choices. This gives you unlimited options to create the best looking tables for the EDL Module. And all modes can be changed at anytime, without losing your designed tables.");

// tb_status.php

define("_NSDLHLPTBSTATUS","Table Activation & Deactivation");
define("_NSDLHLPTBSTATUS2","Table Status");
define("_NSDLHLPTBSTATUS3","When creating tables, you can activate or deactivate the current status of a particular table that you have designed. Only <b>one</b> table can be activated at any given time.<br><br>If a table is activated, then this will be the table that is used for that particular Theme, and that particular table mode, that you have set. If you edit a certain table, and activate it, this will automatically deactivate any table that is already activated.<br><br>If no active tables are present, then the script will warn you of no active tables for that mode, and default to the original Open2 & Close2 tables of that particular theme. You can always activate or deactivate any table at any time.");



// New after 2nd Beta Release



// tb_structure.php

define("_NSDLTBFORMSTRUC","Table Form Structure");
define("_NSDLTBFORMSTRUC2","The table form structure, determines the table's width, cell-padding, cell-spacing, alignment, and border size.<br><br>The problem with the V1.6 of the EDL, is the fact that most people have trouble stretching their Open2 Tables in their themes to the width of 100%.<br><br>This form was created for the people that have no coding experience, to make it easy for them to design custom tables for the module. By default, the forms width of the tables is 100%. If you choose to leave it the way it is, then we recommend adding about 5-10 cell-padding, and a border size of 1.<br><br>You can always preview and change any definitions at anytime.");


// tb_color.php

define("_NSDLTBFORMCOLOR","Table Form Color");
define("_NSDLTBFORMCOLOR2","The table form color settings, provide you a way to add color to your borders and cells within the table. To set the colors through a colorpicker, simply click the 'C' button next to each field, and this opens a ColorPicker. Choose a color of your choice, click the submit button on the Pop Up window, and the color will be added to the form.<br><br>Choose the border and background colors to match the theme that you have loaded. This is what makes these table forms so great... as you can make custom tables with custom colors to match all your current themes.<br><br><b>Do NOT</b> add a <b>#</b> infront of the color code. The script will auto add the character. Again, you can always preview and change any definitions at anytime.");


// tb_html.php

define("_NSDLTBHTMLOPCL","HTML Copy & Paste Table Design");
define("_NSDLTBHTMLOPCL2","With the HTML Copy & Paste mode of the Table Design functions, you can create truely custom tables for the EDL module. The Open & Close part of the form is exactly like your Open & Close functions of your theme.<br><br>You can design tables in your favorite editor, and simply copy and past the open and close part of the code into the text boxes.<br><br>The Open part will control the top and left half of your tables. The close part will control the right and bottom half of your tables, thus splitting the tables in half. This again, is just like in your theme functions. If you need more help on this, view your theme.php file or your tables.php file (if available) in your theme folder. This will give you more understanding on how table structures work.<br><br><b>Note:</b> The 'Preview Table' function is not working properly. You must save the table, and then click the 'View' link in the table list to view the actual table. If you need to change a setting, then simply click the 'Edit' link. This will be fixed in the next sub-version of the module, the EDL V2.1. Sorry for any inconvenience.");



################################
#                              #
#      Upload Definitions      #
#                              #
################################

define("_NSDLUPLOADSETTINGS","NukeStyles EDL V2.0 Upload Settings");
define("_NSDLFILEDIRECTORY","Name of File Directory");
define("_NSDLIMGDIRECTORY","Name of Image Directory");
define("_NSDLALLOWFILE","Allow user's to upload Files");
define("_NSDLALLOWIMG","Allow user's to upload Description Images");
define("_NSDLFILESIZE","Maximum File size");
define("_NSDLIMGSIZE","Maximum Image size");
define("_NSDLINBYTES","in bytes ( 1024 bytes = 1K )");
define("_NSDLFILEALLOWEXT","File extensions allowed");
define("_NSDLIMGALLOWEXT","Image extensions allowed");
define("_NSDLEXTNOTE","Type in your extensions seperated by spaces.<br>Do <b>not</b> use periods ( . ) in front of the extension. ie: gif jpg jpeg");



// Modified after 2nd Beta release

define("_NSDLDIRECTORYNOTE","Creating Directories & Permissions");


// New after 2nd Beta Release

define("_NSDLUPDIRECTORY","Directory Settings");
define("_NSDLDIRECTORYNOTE2","There are several directories that must be created for the Upload settings to work. Since all servers/hosts use different OS & Platforms, it's best to have the direcories created by the site admin.<br><br>First, specify the directory names in the admin form. Then, you will need to create those directories in this folder on your server:<br><br><b>html/modules/Downloads/</b><br><br><font color=\"#cc0000\"><b>CHMOD</b></font> these 2 directories (One for the Files, and one for the Images), to <font color=\"#cc0000\"><b>777</b></font>.<br><br><b>Inside</b> the Image directory that you specified, you need to create another directory called:<br><br><b>thumb</b><br><br>Also <font color=\"#cc0000\"><b>CHMOD</b></font> this directory to <font color=\"#cc0000\"><b>777</b></font>. This directory will hold your resized/enhanced thumbnails of the Description images used in the module.<br><br>All 3 directories must be created, and permissions set, before the Upload settings will work.");
define("_NSDLIMGRESIZE","Image Resize & Thumb Creation");
define("_NSDLNETGDINFO","You currently have the following image libraries installed");
define("_NSDLNONENETGD","<font color=\"#CC0000\">None Found</font>");
define("_NSDLNONENETGD2","Defaults to <b>'No'</b> if binaries are not found.");
define("_NSDLUSENETGD","Use Image Enhance/Resize Functions?");
define("_NSDLUSENETPBMGD","Using NetPBM Binaries or GB Library");
define("_NSDLUSENETPBMGD2","Included in the EDL V2.0 is the option to have your Description images resized and enhanced using either the NetPBM Binaries or the GD Libraries. These codes will help reduce the size of the images that are uploaded, so the Download listings will be faster.<br><br>The script will default to the NetPBM Binaries first, then if those binaries are not accesible or not installed properly, the script will search your host for the GD Libraries to use instead. The option we give is to turn these codes off, for the simple fact they can cause trouble, depending on your server. The code is workable, but still needs a little tweaking that will come in a later version of the EDL, to be released shortly after with a few fixes/enhancments.<br><br>With these codes, any uploaded image will then be made into a smaller thumbnail, reducing the size (KB) of each image. This will allow users browsing your downloads section, to have the pages with description images load faster. A small thumbnail will be created for the default display, but when the Pop Up window is clicked, the regular full sized image will show in the new window. The only problem is, when uploading different sizes of images, being the width & height, some images will appear a bit distorted, depending on your Description Image settings (In your right Admin Block). These settings will give you more options on how the default thumbs are displayed.<br><br>The NetPBM Binaries can be found here: <a href=\"http://www.nukestyles.com\" target=\"_blank\">Here</a>. You have to download the appropriate binaries depending on your servers Platform, being either Linux, Windows, ect. The GD Libraries have to be installed on your server by your Hosting Company. If you not sure, email your host's support, and ask if GD is installed. For more help, refer to the Readme and Installation docs that came with this module, or use the Support Forums at NukeStyles.com, by clicking the Link on your admin block.");

define("_NSDLUPSIZENOTE","If you set the Max File size above 2MB, and the upload limit still maxes out at 2MB... then you will have to edit your <b>php.ini</b> file for your server. This file sets the Max Upload Limit on your server. Contact your Hosting Company to see about setting the Max Upload Limit higher than 2MB.");




################################
#                              #
#    EDL Group Definitions     #
#                              #
################################

define("_NSDLGROUPSETTINGS","NukeStyles EDL V2.0 Group Settings");



################################
#                              #
#   Custom Field Definitions   #
#                              #
################################

define("_NSDLFIELDSSETTINGS","NukeStyles EDL V2.0 Field Settings");
define("_NSDLCURPERMFIELDS","Current Permanent Fields");
define("_NSDLVERSION","<font color=\"#cc0000\"><b>Version:</b></font>");
define("_NSDLCOMPAT","<font color=\"#cc0000\"><b>Compatibility:</b></font>");
define("_NSDLFFILESIZE","<font color=\"#cc0000\"><b>Filesize:</b></font>");
define("_NSDLADDEDON","<font color=\"#cc0000\"><b>Date Added:</b></font>");
define("_NSDLHITS","<font color=\"#cc0000\"><b>Total Downloads:</b></font>");
define("_NSDLRATING","<font color=\"#cc0000\"><b>Rating:</b></font>");
define("_NSDLCURNEWFIELDS","Current New Fields");
define("_NSDLNONEWFIELDS","No New Fields");
define("_NSDLBADDFIELD","Add Field");
define("_NSDLADDNEWFIELD","Add New Field");
define("_NSDLEDITFIELD","Edit New Field");
define("_NSDLDELETEFIELD","<font color=\"#CC0000\">Warning!</font><br><br>Are you sure you want to delete this field?<br><br><b>All</b> values associated with this field will be lost!");




// fld_new

define("_NSDLHLPFIELDNEW","New Field Help");
define("_NSDLCURPERMFIELDS2","You have the option to Enable/Disable any of the Permanent Fields. These settings are for display <b>only</b>. The Field itself is not affected, and still holds any previous data that was included. This allows you to change the display at any given time.<br><br>But... if a field is disabled, then in the Add Download for user's, it will not display and the value will be null. You can always enable the display, and then add a value later on.");

// fld_perm

define("_NSDLHLPFIELDPERM","Permanent Field Help");
define("_NSDLCURNEWFIELDS2","You have the option to Add new Fields for the Enhanced Downloads module. The added fields will be generic, so any values can be added to the DataBase.<br><br>For example, you can add a field for 'Price', 'License', 'Platform', or anything in between. You can also add as many fields as you want.<br><br>Please becareful deleting fields, as once the field is deleted, then ALL values from previous additions will be lost, and the values will not be retrievable.");



// New after 2nd Beta Release

define("_NSDLFLCOMING","Coming in the EDL V2.1 (Which is Free to those who purchased V2.0), will be the ability to enable/disable/rename 10 generic fields in the Download Module. This will allow admins to use more than the standard fields. For example: Fields for Platform, Price, OS, ect.");



#################################
#                               #
#  Description Img Definitions  #
#                               #
#################################

define("_NSDLDESCRPTIMGSETTINGS","NukeStyles EDL V2.0 Description Image Settings");
define("_NSDLCENTERUP","Center Up");
define("_NSDLCENTERDOWN","Center Down");
define("_NSDLDESIMAGE4","Have the Pop Window conform to the Image size?<br>Or set Standard Height and Width of all Pop Windows?");
define("_NSDLCONFORM","Conform to Image Size");
define("_NSDLSETWIDHEI","Standard Height-Width");
define("_NSDLDESIMAGE5","If standard is selected, set your width & height");



// New after 2nd Beta Release

define("_NSDLUSERESIZE","Let NetPBM or GD control thumbnail size?");
define("_NSDLUSERESIZE2","If standard size is set, and image resize option is <b>On</b> (Upload Settings),<br>then some small or odd sized images might appear a bit distorted.");


################################
#                              #
#    Add/Modify Definitions    #
#                              #
################################

define("_NSDLADDMODSETTINGS","NukeStyles EDL V2.0 Add/Modify Settings");
define("_NSDLOWNERMODDL","<b>Important:</b> It was brought to my attention that with the Modify functions available, it was easy for the 'Leechers' to get direct access to the original url of the Download. The setting below will help deter those bums from getting the direct download link, by only allowing the orginal download owner to suggest modifications. Check 'Yes' field to stop all others from even seeing the download information, unless they are the original owner.");
define("_NSDLOWNERMODDL2","<b>Only</b> original Owner can suggest modifications");
define("_NSDLOWNERMODDL3","If set to 'Yes', below settings do not apply.");



################################
#                              #
#      Ratings Definitions     #
#                              #
################################

define("_NSDLRATESETTINGS","NukeStyles EDL V2.0 Rating Settings");



################################
#                              #
#  Featured Links Definitions  #
#                              #
################################

define("_NSDLFEATSETTINGS","NukeStyles EDL V2.0 Featured Links Settings");



################################
#                              #
#    New-Pop-Top Definitions   #
#                              #
################################

define("_NSDLNEWPOPTOPSETTINGS","NukeStyles EDL V2.0 New-Popular-Top Rated Settings");
define("_NSDLNEWIMAGENAME1","New Image for 'Brand New'");
define("_NSDLNEWIMAGENAME2","New Image for 'Relatively New'");
define("_NSDLNEWIMAGENAME3","New Image for 'Getting Old'");




// New after 2nd Beta Release


################################
#                              #
# Manage File/Img Definitions  #
#                              #
################################

define("_NSDLMANAGEFLIMG","NukeStyles EDL V2.0 File & Image Management");
define("_NSDLMANAGENOTE","Below are Files & Description Images that are not attached to any Download, either by erroneous Uploads, or left overs. You have the option to Delete these files or images, by simply clicking the button. You also have the option to view All Files or All Images attached to All Downloads. There, you have the option to Edit or Delete the specific download to change the files or images.");
define("_NSDLUNATTFILES","Unattached Files");
define("_NSDLUNATTIMGS","Unattached Description Images");
define("_NSDLATTFILES","Attached Files");
define("_NSDLATTIMGS","Attached Description Images");
define("_NSDLSHOWALLFILES","Attached Files");
define("_NSDLSHOWALLIMGS","Attached Images");
define("_NSDLUNATTDELALL","Delete All");
define("_NSDLSUREDELALLUNFILES","<font color=\"#CC0000\">Warning!</font><br><br>Are you sure you want to delete all Unattached Files?");
define("_NSDLSUREDELALLUNIMGS","<font color=\"#CC0000\">Warning!</font><br><br>Are you sure you want to delete all Unattached Images?");
define("_NSDLUNLINKFILE","There was a problem Deleting the File:");
define("_NSDLUNLINKFILE2","Either try again, or delete the File manually.");
define("_NSDLUNLINKFILECHM","There was a problem setting permission's to delete the File:");
define("_NSDLUNLINKIMG","There was a problem Deleting the Image:");
define("_NSDLUNLINKIMG2","Either try again, or delete the Image manually.");
define("_NSDLUNLINKIMGCHM","There was a problem setting permission's to delete the Image:");
define("_NSDLNOUNATTFILES","No Unattached Files.");
define("_NSDLVIEWIMG"," View ");
define("_NSDLFCHECK","Check");
define("_NSDLMANAGEALLNOTE","Below are all the Files attached to each Download. Only files that were uploaded from the Add Download form (Admin & User) are included. Here, you have the option to Check the File or Edit the Download.");
define("_NSDLMANAGEALLINOTE","Below are all the Description Images attached to each Download. Only images that were uploaded from the Add Download form (Admin & User) are included. Here, you have the option to View the Image or Edit the Download.");
define("_NSDLMANAGEHOME","Manage Home");
define("_NSDLTITLE","Download Title");
define("_NSDLMANAGEFILE","File Name");


define("_NSDLNETPBMDIRECTORY","Path to NetPBM Binaries");

?>